-- FULL DESCRIPTION CAN BE FOUND HERE: https://github.com/Chalwk77/HALO-SCRIPT-PROJECTS/releases/tag/AdminManager

return {

    --- TERMINAL ADMIN LEVEL:
    --
    -- Default level for the server console:
    -- This should always be the max level.
    -- Default: (6)
    console_default_level = 6,


    --- PASSWORD LENGTH:
    --
    -- Minimum and maximum password length for password admins:
    -- Default (8, 32)
    password_length_limit = { 8, 32 },


    --- ADMIN LEVEL DELETE TIMEOUT:
    --
    -- Confirmation timeout (in seconds) for deleting admin levels:
    -- If a player doesn't confirm the deletion within this time, the deletion is cancelled.
    -- Default: (10)
    confirmation_timeout = 10,


    --- DEFAULT BAN DURATION:
    --
    -- Players are banned for this duration if no duration is specified:
    default_ban_duration = {
        y = 0, -- years
        mo = 0, -- months
        d = 0, -- days
        h = 1, -- hours
        m = 0, -- minutes
        s = 0-- seconds
    },


    --- DATABASE FILES:
    --
    -- All files are in JSON format:
    files = {

        -- Admins:
        -- This file is automatically generated and CAN be edited (but restart the server after editing).
        [1] = 'admins.json',

        -- Commands:
        -- This file is automatically generated and CAN be edited (but restart the server after editing).
        [2] = 'commands.json',

        -- Bans:
        -- This file is automatically generated and should not be edited.
        [3] = 'bans.json',

        -- Logging:
        -- This file is automatically generated and should not be edited.
        [4] = 'logs.json',

        -- Aliases:
        -- This file is automatically generated and should not be edited.
        [5] = 'aliases.json'
    },


    --- SAPP VARIABLES SETTINGS
    --
    -- External scripts can rely on player's admin levels, we provide a way for accessing them
    -- through SAPP's custom variables.
    -- Credits to @edgardanielgd for this.
    -- > https://github.com/edgardanielgd
    custom_level_var = 'admin_level',


    --- LOGGING:
    --
    -- When enabled, command logs are saved to the ./Admin Manager/logs.json file.
    logging = {

        -- Log management commands and ban actions:
        -- Default: (true)
        management = true,

        -- Log all other commands:
        -- Default: (true)
        default = true,
    },


    --- CUSTOM JOIN MESSAGES FOR ADMINS:
    --
    -- Format: [admin level] = {'custom join message', enabled/disabled (true/false)}}
    admin_join_messages = {
        enabled = false,
        [1] = { '[PUBLIC] %s joined the server.', false },
        [2] = { '[ADMIN] %s just showed up. Hold my beer!', true },
        [3] = { '[MOD] %s just joined. Hide your bananas!', true },
        [4] = { '[VIP] %s joined the server. Sexy is as sexy does.', true },
        [5] = { '[PRO] %s joined the server. Pro noob.', true },
        [6] = { '[OWNER] %s joined the server. Everybody hide!', true },
    },


    --- COMMAND SPY:
    --
    -- When enabled, admins will be able to see commands executed by players.
    -- You will only see commands from players with a lower or equal level to you.
    -- Format: [admin level] = true (or false)
    command_spy = {
        [1] = false,
        [2] = false,
        [3] = true,
        [4] = true,
        [5] = true,
        [6] = true
    },


    --- ADMIN CHAT:
    --
    -- When enabled, admins will be able to see admin-chat messages.
    -- You will only see messages from players with a lower or equal level to you.
    -- Format: [admin level] = true (or false)
    admin_chat = {
        [1] = false,
        [2] = true,
        [3] = true,
        [4] = true,
        [5] = true,
        [6] = true
    },


    --- CUSTOM MANAGEMENT COMMANDS:
    --
    -- These are the custom Admin Manager commands that are available to players at each level:
    -- For default commands, see the next section (default_commands).
    -- These commands are not (and shouldn't) be added to the commands database JSON file.
    -- Format: ['<level>'] = { ['<command>'] = true (or false) ... }
    -- Setting a command to false will disable it for all players (except console)
    -- Default: (all true)
    management_commands = {

        ['1'] = { -- level 1
            ['login'] = true,
            ['logout'] = true,
        },

        ['2'] = { -- level 2
            ['admin_chat'] = true,
            ['change_password'] = true, -- used to change your own password (see change_admin_password for changing another players password).
        },

        ['3'] = { -- level 3
            ['command_spy'] = true,
            ['ip_mute'] = true,
            ['ip_mutes'] = true,
            ['ip_unmute'] = true,
            ['hash_mute'] = true,
            ['hash_mutes'] = true,
            ['hash_unmute'] = true,
        },

        ['4'] = { -- level 4
            ['alias_ip'] = true,
            ['alias_hash'] = true,
            ['ip_ban'] = true,
            ['ip_bans'] = true,
            ['ip_unban'] = true,
        },

        ['5'] = { -- level 5
            ['confirm'] = true, -- for hash_ban and level delete
            ['hash_admin_add'] = true,
            ['hash_admin_delete'] = true,
            ['hash_admins'] = true,
            ['hash_ban'] = true,
            ['hash_bans'] = true,
            ['hash_unban'] = true,
            ['ip_admin_add'] = true,
            ['ip_admin_delete'] = true,
            ['ip_admins'] = true,
            ['name_ban'] = true,
            ['name_bans'] = true,
            ['name_unban'] = true,
            ['pw_admin_add'] = true,
            ['pw_admins'] = true,
            ['pw_admin_delete'] = true,
        },

        ['6'] = { -- level 6
            ['change_admin_password'] = true, -- used to change another player's password
            ['level_add'] = true,
            ['level_delete'] = true,
            ['change_level'] = true,
            ['set_command'] = true,
            ['disable_command'] = true,
            ['enable_command'] = true,
        }
    },


    --
    --- DEFAULT COMMANDS:
    --
    -- These are the default commands that are available to players at each level:
    -- When the plugin is first installed, these commands are copied to the `commands.json` file.
    -- You can edit the commands in the ./commands.json file, or use the management commands to change them.
    --
    -- Format: ['<level>'] = { ['<command>'] = true (or false) ... }
    -- Setting a command to false will disable it for all players (except console).
    -- Note: If a command is not in this list, it will be disabled for all players.
    -- Default: (all true)
    default_commands = {

        ['1'] = { -- public commands
            ['login'] = true,
            ['logout'] = true,
            ['whatsnext'] = true,
            ['unstfu'] = true,
            ['stats'] = true,
            ['stfu'] = true,
            ['sv_stats'] = true,
            ['info'] = true,
            ['lead'] = true,
            ['clead'] = true,
        },

        ['2'] = { -- level 2
            ['kdr'] = true,
            ['mapcycle'] = true,
            ['pl'] = true,
            ['say'] = true,
        },

        ['3'] = { -- level 3
            ['afk'] = true,
            ['afks'] = true,
            ['skips'] = true,
            ['aimbot_scores'] = true,
            ['k'] = true,
        },

        ['4'] = { -- level 4
            ['ip'] = true,
            ['tell'] = true,
            ['uptime'] = true,
            ['balance_teams'] = true,
            ['st'] = true,
            ['inf'] = true,
        },

        ['5'] = { -- level 5
            ['map'] = true,
            ['maplist'] = true,
        },

        ['6'] = { -- level 6
            ['teamup'] = true,
            ['report'] = true,
            ['admin_prefix'] = true,
            ['usage'] = true,
            ['afk_kick'] = true,
            ['about'] = true,
            ['aimbot_ban'] = true,
            ['ammo'] = true,
            ['anticamp'] = true,
            ['anticaps'] = true,
            ['anticheat'] = true,
            ['antiglitch'] = true,
            ['antihalofp'] = true,
            ['antilagspawn'] = true,
            ['antispam'] = true,
            ['antiwar'] = true,
            ['area_add_cuboid'] = true,
            ['area_add_sphere'] = true,
            ['area_del'] = true,
            ['area_list'] = true,
            ['area_listall'] = true,
            ['assists'] = true,
            ['auto_update'] = true,
            ['ayy lmao'] = true,
            ['battery'] = true,
            ['beep'] = true,
            ['block_all_objects'] = true,
            ['block_all_vehicles'] = true,
            ['block_object'] = true,
            ['block_tc'] = true,
            ['boost'] = true,
            ['camo'] = true,
            ['cevent'] = true,
            ['chat_console_echo'] = true,
            ['cmd_add'] = true,
            ['cmd_del'] = true,
            ['cmdstart1'] = true,
            ['cmdstart2'] = true,
            ['color'] = true,
            ['console_input'] = true,
            ['coord'] = true,
            ['cpu'] = true,
            ['custom_sleep'] = true,
            ['d'] = true,
            ['deaths'] = true,
            ['debug_strings'] = true,
            ['disable_all_objects'] = true,
            ['disable_all_vehicles'] = true,
            ['disable_backtap'] = true,
            ['disable_object'] = true,
            ['disable_timer_offsets'] = true,
            ['disabled_objects'] = true,
            ['dns'] = true,
            ['enable_object'] = true,
            ['eventdel'] = true,
            ['events'] = true,
            ['files'] = true,
            ['gamespeed'] = true,
            ['god'] = true,
            ['gravity'] = true,
            ['hill_timer'] = true,
            ['hp'] = true,
            ['kill'] = true,
            ['kills'] = true,
            ['lag'] = true,
            ['loc_add'] = true,
            ['loc_del'] = true,
            ['loc_list'] = true,
            ['loc_listall'] = true,
            ['log'] = true,
            ['log_name'] = true,
            ['log_note'] = true,
            ['log_rotation'] = true,
            ['lua'] = true,
            ['lua_api_v'] = true,
            ['lua_call'] = true,
            ['lua_list'] = true,
            ['lua_load'] = true,
            ['lua_unload'] = true,
            ['m'] = true,
            ['mag'] = true,
            ['map_download'] = true,
            ['map_load'] = true,
            ['map_next'] = true,
            ['map_prev'] = true,
            ['map_query'] = true,
            ['map_skip'] = true,
            ['map_spec'] = true,
            ['mapcycle_add'] = true,
            ['mapcycle_begin'] = true,
            ['mapcycle_del'] = true,
            ['mapvote'] = true,
            ['mapvote_add'] = true,
            ['mapvote_begin'] = true,
            ['mapvote_del'] = true,
            ['mapvotes'] = true,
            ['max_idle'] = true,
            ['max_votes'] = true,
            ['motd'] = true,
            ['msg_prefix'] = true,
            ['mtv'] = true,
            ['nades'] = true,
            ['network_thread'] = true,
            ['no_lead'] = true,
            ['object_sync_cleanup'] = true,
            ['packet_limit'] = true,
            ['ping_kick'] = true,
            ['query_add'] = true,
            ['query_del'] = true,
            ['query_list'] = true,
            ['reload'] = true,
            ['reload_gametypes'] = true,
            ['remote_console'] = true,
            ['remote_console_list'] = true,
            ['remote_console_port'] = true,
            ['rprint'] = true,
            ['s'] = true,
            ['sapp_console'] = true,
            ['sapp_mapcycle'] = true,
            ['sapp_rcon'] = true,
            ['save_respawn_time'] = true,
            ['save_scores'] = true,
            ['say_prefix'] = true,
            ['score'] = true,
            ['scorelimit'] = true,
            ['scrim_mode'] = true,
            ['set_ccolor'] = true,
            ['setcmd'] = true,
            ['sh'] = true,
            ['sj_level'] = true,
            ['spawn'] = true,
            ['spawn_protection'] = true,
            ['t'] = true,
            ['team_score'] = true,
            ['text'] = true,
            ['timelimit'] = true,
            ['tp'] = true,
            ['unblock_object'] = true,
            ['ungod'] = true,
            ['unlag'] = true,
            ['unlock_console_log'] = true,
            ['v'] = true,
            ['var_add'] = true,
            ['var_conv'] = true,
            ['var_del'] = true,
            ['var_list'] = true,
            ['var_set'] = true,
            ['vdel'] = true,
            ['vdel_all'] = true,
            ['venter'] = true,
            ['vexit'] = true,
            ['wadd'] = true,
            ['wdel'] = true,
            ['wdrop'] = true,
            ['yeye'] = true,
            ['zombies'] = true,
        }
    },

    [[

        -------------------
        Advanced users only:
        -------------------

        Client login sessions for Username & Password based admins are temporarily cached.

        You will not have to log into your account again when you quit and rejoin unless:
        1). The server is restarted.
        2). Your IP address changes.
        3). Your client port changes (depending on config, see more on that below).

        The below setting (cache_session_index) will keep login sessions by IP or IP:PORT for 24 hours (default)
        The default setting is IP:PORT (index 1).

        IP:PORT caching is recommended.
        This does, however, require that players always have the same port, otherwise they will have to login every time they join.

        Furthermore, if there are multiple admins on the same network (same IP), theoretically, one of them
        could hijack the other's session by changing their username (IGN) to match the other's.

        No two players can have the same IP:PORT, so this is not an issue unless the other admin joins by themselves
        on the same network with your username.

        Technical notes:
        * Setting your in-game client port to 0 will force your client to use a random port.
        * Some chimera users have the 'client_port' set to 0. This is not recommended.
    ]],

    cache_session_index = 1,

    --
    -- Login sessions will expire after this amount of time (in hours):
    --
    login_timeout = 24 -- hours
}